#include "aboutbox.h"
#include "ui_aboutbox.h"
#include <QTextCodec>

AboutBox::AboutBox(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::AboutBox)
{
    ui->setupUi(this);
    company = new QLabel(this);
    company->setObjectName(QStringLiteral("company"));
    company->setGeometry(QRect(11, 160, 381, 20));
    company->setAlignment(Qt::AlignCenter);
    telfax = new QLabel(this);
    telfax->setObjectName(QStringLiteral("TELFAX"));
    telfax->setGeometry(QRect(20, 180, 361, 20));
    telfax->setAlignment(Qt::AlignCenter);
    webmail = new QLabel(this);
    webmail->setObjectName(QStringLiteral("WEBEMAIL"));
    webmail->setGeometry(QRect(20, 200, 361, 20));
    webmail->setAlignment(Qt::AlignCenter);

    connect(ui->pushButton, SIGNAL(clicked()), this, SLOT(slot_ok()));
}

AboutBox::~AboutBox()
{
    delete company;
    delete telfax;
    delete webmail;
    delete ui;
}

void AboutBox::showEvent(QShowEvent *event)
{
    int			total;
    OKDEVTYPE	*lpBoardInfo;

    QString str;
    int		number,blknum;
    long	bufbits,bufsize;
    LPBYTE	lpPhys,lpLinear,lpCurrBase;
    MWORD		dwBufSize;
    char        pgm[100];

    total=okGetImageDevice(&lpBoardInfo,0);

    if(iCurrUsedNo<0)
        return;

    str = QString("当前使用的卡型： (No. %1) %2")
            .arg(iCurrUsedNo, 0, 10)
            .arg(lpBoardInfo[iCurrUsedNo].szBoardName);

    ui->CURRUSED->setText(str);

    lpPhys=(LPBYTE)okGetAvailBuffer((void **)&lpLinear, &dwBufSize); //total
    number=okGetBufferSize(hBoard, (void **)&lpCurrBase, &dwBufSize); //current
    str = QString("序列缓存:  %1(%2): %3 M ")
            .arg(MWORD(lpPhys+(DWORD)(lpCurrBase-lpLinear)), 0, 16)
            .arg(MWORD(lpCurrBase), 0, 16)
            .arg(dwBufSize/1024/1024, 0, 10);
    ui->BUFFERSIZE->setText(str);

    bufbits=HIWORD(okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,GETCURRPARAM)); //-1
    bufsize=okSetCaptureParam(hBoard,CAPTURE_BUFBLOCKSIZE,GETCURRPARAM); //-1
    number=okGetBufferSize(hBoard,NULL,NULL);

    blknum=okGetMemBlock(hBoard,NULL,NULL);
    str = QString("当前缓存帧数:%1+%2 (%3x%4x%5)")
            .arg(number-blknum, 0, 10)
            .arg(blknum, 0, 10)
            .arg(LOWORD(bufsize), 0, 10)
            .arg(HIWORD(bufsize), 0, 10)
            .arg(bufbits, 0, 10);
    ui->FRAMESIZE->setText(str);

    str = QString("程序申请内存大小: %1 M")
            .arg(dwMaxMemSize/1024/1024, 0, 10);
    ui->MEMORYSIZE->setText(str);

    //set manufacture infos
    okGetProgramInfo(PROGRAM, pgm, 100); //name
    QTextCodec *codec=QTextCodec::codecForName("GB2312");
    str=codec->toUnicode(pgm,strlen(pgm));
    ui->PROGRAMINFO->setText(str);

    char cTmp[100];
    str = "Copyright 1999-2024   Ver. ";  //
    okGetProgramInfo(VERSION, cTmp, 100); //version
    str += QString(cTmp);
    ui->VERSIONSHOW->setText(str);

    okGetProgramInfo(8, cTmp, 100); //CREATEDATE
    ui->DRIVERDATE->setText(QString(cTmp));

    okGetProgramInfo(COMPANY, pgm, 100); //name COMPANY
    codec=QTextCodec::codecForName("GB2312");
    str=codec->toUnicode(pgm,strlen(pgm));
    company->setText(str);

    okGetProgramInfo(TELFAX, pgm, 100); //name COMPANY
    codec=QTextCodec::codecForName("GB2312");
    str=codec->toUnicode(pgm,strlen(pgm));
    telfax->setText(str);

    okGetProgramInfo(WEBEMAIL, pgm, 100); //name COMPANY
    codec=QTextCodec::codecForName("GB2312");
    str=codec->toUnicode(pgm,strlen(pgm));
    webmail->setText(str);


}

void AboutBox::slot_ok()
{
    close();
}

void AboutBox::SetCurrentNo(MLONG m)
{
    iCurrUsedNo = m;
}

void AboutBox::SetBoard(HANDLE h)
{
    hBoard = h;
}

void AboutBox::SetMaxMem(DWORD m)
{
    dwMaxMemSize = m;
}

