﻿#ifndef ABOUTBOX_H
#define ABOUTBOX_H

#include <QDialog>
#include <qlabel.h>

#if defined(Q_OS_WIN64)
    #include "Windows.h"
    #include "Okapi64.h"
#elif defined(Q_OS_WIN32)
    #include "windows.h"
    #include "Okapi32.h"
#else
    #include "../share/winsim.h"
    #include "../share/okapi64.h"
#endif

namespace Ui {
class AboutBox;
}

class AboutBox : public QDialog
{
    Q_OBJECT

public:
    explicit AboutBox(QWidget *parent = 0);
    ~AboutBox();

    void showEvent(QShowEvent *event);

public slots:
    void slot_ok();

private:
    Ui::AboutBox *ui;

public:
    HANDLE		hBoard;
    MLONG       iCurrUsedNo = -1;
    DWORD		dwMaxMemSize;
    QLabel      *company;
    QLabel      *telfax;
    QLabel      *webmail;

    void SetBoard(HANDLE h);
    void SetCurrentNo(MLONG m);
    void SetMaxMem(DWORD m);
};

#endif // ABOUTBOX_H
