﻿#include "bufferdlgbox.h"
#include "ui_bufferdlgbox.h"

#if defined(Q_OS_WIN64)
    #include "Windows.h"
    #include "Okapi64.h"
#elif defined(Q_OS_WIN32)
    #include "windows.h"
    #include "Okapi32.h"
#else
    #include "../share/winsim.h"
    #include "../share/okapi64.h"
#endif

BufferDlgBox::BufferDlgBox(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::BufferDlgBox)
{
    ui->setupUi(this);

    MWORD	currsize,newsize;

    okGetAvailBuffer(NULL,&currsize); //in byte
    currsize>>=10; //to k byte
    ui->CURRENTSIZE->setText(QString::number(currsize));

    newsize=okSetAllocBuffer(-1); //just get last set in k byte
    ui->NEWBUFSIZE->setText(QString::number(newsize));

    connect(ui->buttonBox, SIGNAL(accepted()), this, SLOT(slot_OnAccepted));
}

BufferDlgBox::~BufferDlgBox()
{
    delete ui;
}

void BufferDlgBox::slot_OnAccepted()
{
    MWORD	newsize;

    newsize = ui->NEWBUFSIZE->text().toInt();
    okSetAllocBuffer(newsize); //set new
}
