﻿#include "mainwindow.h"
#include <QApplication>

#include "stdio.h"

#if defined(Q_OS_WIN64)
    #include "Windows.h"
    #include "Okapi64.h"
#elif defined(Q_OS_WIN32)
    #include "windows.h"
    #include "Okapi32.h"
#else
    #include "../share/winsim.h"
    #include "../share/okapi64.h"
#endif

long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *height);
long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form);

MainWindow  *mainwin;

long		elapsed;
long		numframe;
char		string[256];
MLONG		bufform;
BLOCKINFO	blk;
long		num;
float		ratio=25;

BOOL				bDispToScreen;
LPBITMAPINFOHEADER	lpbi = NULL;
LPBYTE				lpdib = NULL;

//-- calculate capture ratio by counting callback
float exCalcCaptureRatio()
{
    static	DWORD	times;

    if( (num>=12) ||  ((okGetTickCount()-times)>2000)&&(num>=2) ) {
        times=okGetTickCount()-times;
        ratio=((float)num*1000/times);
        num=0;
    }

    if(num==0)
        times=okGetTickCount();
    num++;

    return ratio;
}


//--set data to dib in blk by convert
long CALLBACK exSetToScreen(HANDLE hBoard, long no)
{
    long	elapsed;
    /*
    {
        LOGFONT 	lfLogFont={ -20, 0, 0, 0, 400, 0, 0, 0, 0, 1, 2, 1, 26, "Arial"};
        SETTEXTMODE	textmode={0xffffff,0xf0,0,0,0};  //
        RECT		rect= {0,100,0,0};
        char		text[20];
        static		number=0;

        textmode.wFrameNo=no;
        number++;
        sprintf(text,"number=%d",number);
        okSetTextTo(hBoard, BUFFER, &rect, &lfLogFont, &textmode, text, 8);
        //okSleep(20);
    }
    */

    //way 1
    okConvertRect(hBoard, (TARGET)&blk, 0, BUFFER, (short)no, 1);//MAKELONG(1,2));//1);
    //okConvertRectEx(hBoard,(TARGET)&blk,0,hBoard,BUFFER,(short)no,1);//MAKELONG(1,2));//1);
    //okTransferRect(hBoard,(TARGET)&blk,0,BUFFER,(short)no,1);
    //way 2
    //okReadRect(hBoard,BUFFER,(short)no,lpdib);
    //exConvertBitmap(lpbi,lpdib);

    elapsed = okGetTickCount();

    //SendMessage(hwnd,WM_PAINT,0,0l);
    mainwin->update();

    elapsed = okGetTickCount() - elapsed;

    return elapsed;
}



//------------callback example runtines----------
//bDispToScreen=0: not back display
//				1, back display
//				2: back display, and take same bits as screen
//				3: pseudo back display

BOOL CALLBACK exBeginCapture(HANDLE hBoard)
{
    short		width,height;
    MLONG		form;

    if(bDispToScreen) {
        bufform=exGetTargetSize(hBoard, BUFFER, &width, &height);

        form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
        if((form<0)||(form ==0xffff))
        {

            form = 0x200004;
        }
        { //treat rotate
            short temp;

            temp=(short)okSetConvertParam(hBoard,CONVERT_UPRIGHT,-1); //un
            if(temp>0) {
                temp=width;
                width=height;
                height=temp;
            }
        }

        exSetBitmapHeader(lpbi, width, height, HIWORD(form), LOWORD(form) );

        if(bDispToScreen>1) { //take same bits as screen for callback exSetToScreen

            if(bDispToScreen==3) { //make pseudo-display
                int					i;
                #define	way1

                #ifdef	way1
                //way1 by convert
                {
#if defined(Q_OS_WIN32)
                    PALETTEENTRY		palPalEntry[256];
#endif

                    exSetBitmapHeader(lpbi, width, height, HIWORD(form), LOWORD(form) );

#if defined(Q_OS_WIN32)
                    if(LOWORD(bufform)==FORM_RGB888) { //negative when color source
                        for (i = 0; i<256; i++ ) {
                            palPalEntry[i].peRed = (BYTE)(255-i);
                            palPalEntry[i].peGreen = (BYTE)(255-i);
                            palPalEntry[i].peBlue = (BYTE)(255-i);
                            palPalEntry[i].peFlags = 0;
                        }
                    }
                    else { //gray8 just exam to set palette to yellow
                        for (i = 0; i<256; i++ ) {
                            palPalEntry[i].peRed = (BYTE)(i);
                            palPalEntry[i].peGreen = (BYTE)(i);
                            palPalEntry[i].peBlue = (BYTE)(0);
                            palPalEntry[i].peFlags = 0;
                        }
                    }
                    okSetConvertParam(hBoard, CONVERT_PALETTE, (LPARAM)palPalEntry);
#endif
                }
                #else
                //way2 by windows palette
                {
                    RGBQUAD	*lpRGB=(RGBQUAD *)((LPSTR)lpbi+lpbi->biSize);

                    for (i = 0; i<256; i++ ) {
                        lpRGB[i].rgbRed = (BYTE)i;
                        lpRGB[i].rgbGreen = (BYTE)i;
                        lpRGB[i].rgbBlue = (BYTE)0;
                        lpRGB[i].rgbReserved = 0;
                    }
                }
                #endif
            }
        }


    }

    blk.iType=BMPHEADER;  //data is dib format
    blk.lpBits=(LPBYTE)lpdib;
    blk.iBitCount=lpbi->biBitCount;

    //if(bMakeMirror&1) //x mirror
    //	blk.iWidth=-(short)lpbi->biWidth;
    //else
        blk.iWidth=(short)lpbi->biWidth;

    if( okSetCaptureParam(hBoard,CAPTURE_SAMPLEFIELD,-1)==0 ) //sample in field by field
        if( LOWORD(okSetVideoParam(hBoard,VIDEO_SIGNALTYPE,-1))==1 ) //interlace video
            if(okSetConvertParam(hBoard,CONVERT_FIELDEXTEND,-1)!=0 )
                lpbi->biHeight*=2; //double size for ht

    //if(bMakeMirror&2) //y mirror
    //    blk.iHeight=(short)lpbi->biHeight; // y mirror
    //else
        blk.iHeight=-(short)lpbi->biHeight; //note: minus is for invert dib in y by ConvertRect

//	lScrnOffset=SetToWndRectEx(hBoard,hwnd,bScrnCenter);

    elapsed=okGetTickCount();
    numframe=0;

    num=0;

    return 1;
}






BOOL CALLBACK exBackDisplay(HANDLE hBoard, MLONG no)
{
    MLONG	elapsed=0;
    numframe++;

    //okWaitVerticalSync(hBoard,0); //test ???

    //okGetLineReady(hBoard, NULL,0);
    if(bDispToScreen) {
        //long	elapsed=okGetTickCount();

        elapsed=exSetToScreen(hBoard, (int)no);
        {
            //POINT	pt0,pt1;
            //int		count;
            //	SetRect(&rect,100,100,300,300);
            //pt0.x=100; pt0.y=100;
            //pt1.x=0; pt1.y=100;
            //count=okDrawLineTo(hBoard,SCREEN,0,pt0,pt1,0xff);
        }
        //sprintf(string," Capture ratio = %d; Captured frames = %d ", exCalcCaptureRatio(), numframe);
        sprintf(string," Ratio = %5.2f; Total frames =%6i; Current =%6i;  Paint times=%4i     ",exCalcCaptureRatio(),numframe, no,elapsed);
    }
    else {
        //sprintf(string," Capture ratio = %d; Captured frames = %d ", exCalcCaptureRatio(), numframe);
        sprintf(string," Ratio = %5.2f; Total frames =%6i; Current =%6i ",exCalcCaptureRatio(),numframe, no);
    }

#if defined(Q_OS_WIN32)
    SetWindowTextA((HWND)mainwin->winId(), string);
#endif

    return 1;
}




BOOL CALLBACK exEndCapture(HANDLE hBoard)
{

    sprintf(string,"Total frames = %d;  elapsed time= %d ms",numframe,okGetTickCount()-elapsed);
#if defined(Q_OS_WIN32)
    SetWindowTextA((HWND)mainwin->winId(),string);
#endif

    //clear callback
    //okSetSeqCallback(hBoard,NULL,NULL,NULL); //disable this way

    //okStopCapture(hBoard); //disable this way

    return 1;
}


//get target size
long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *height)
{
    RECT	rect;
    long	form;


    if( (tgt==SCREEN ) ||(tgt==BUFFER) ) {
        rect.right=-1;
        okSetTargetRect(hBoard,tgt,&rect); //get current rect
        if(width)
            *width=(short)(rect.right-rect.left);
        if(height)
            *height=(short)(rect.bottom-rect.top);

        if(tgt==SCREEN ) {
            form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
            //limit to video rect
            rect.right=-1; //max. captured rect
            okSetTargetRect(hBoard,VIDEO,&rect); //get video rect
            if(width)
                *width = (short)qMin(long(*width), long(rect.right-rect.left));
            if(height)
                *height = (short)qMin(long(*height), long(rect.bottom-rect.top));
        }
        else if(tgt==BUFFER)
            form=okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,GETCURRPARAM); //-1

    } else if(tgt>BUFFER) { //from blkinfo
        LPBLOCKINFO	lpblk;
        lpblk=(LPBLOCKINFO)tgt;

        if(width)
            *width=lpblk->iWidth;
        if(height)
            *height=abs(lpblk->iHeight);
        form=MAKELONG(lpblk->iFormType,lpblk->iBitCount);
    }


    return form;
}

//set bitmap header and bitmap info if need
long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form)
{
    long	wbytes;

    if(!lpbi)
        return FALSE;


    if(form==FORM_RGB555)
        bits=16;
    wbytes=((((width*bits)+31)&~31)>>3);//bmp need 4 byte align

    lpbi->biWidth=width;
    lpbi->biHeight=height;

    lpbi->biSize=sizeof(BITMAPINFOHEADER);
    lpbi->biPlanes=1;

    lpbi->biBitCount=bits;
    lpbi->biSizeImage=wbytes*height;


    lpbi->biClrUsed=0;
    //special format for 555,565 & 32
    if(form==FORM_RGB555 || form==FORM_RGB565 || form==FORM_RGB8888 || form==FORM_RGB8886)
        lpbi->biCompression=BI_BITFIELDS;
    else
        lpbi->biCompression=0;
    if(lpbi->biCompression==BI_BITFIELDS ) {//
        DWORD	*lpmask;
        lpmask=(DWORD *)((LPSTR)lpbi+lpbi->biSize);

        if(form==FORM_RGB555) {
            lpmask[2]=0x001f; //blue
            lpmask[1]=0x03e0;
            lpmask[0]=0x7c00;
        }
        else if(form==FORM_RGB565) {
            lpmask[2]=0x001f; //blue
            lpmask[1]=0x07e0;
            lpmask[0]=0xf800;
        }
        else if(bits==32 ) {
            lpmask[2]=0x0000ff;
            lpmask[1]=0x00ff00;
            lpmask[0]=0xff0000;
        }
    }
    else if(bits<=14) { // 8,10,12
        int		i,ratio;
        RGBQUAD	*lpRGB=(RGBQUAD *)((LPSTR)lpbi+lpbi->biSize);

        lpbi->biClrUsed=(1<<bits);
        ratio=lpbi->biClrUsed/256;

        lpbi->biClrUsed = qMin((DWORD)256,lpbi->biClrUsed); //limit
        for(i=0; i<(short)lpbi->biClrUsed;i++) {
            lpRGB[i].rgbBlue=i;//i/ratio;
            lpRGB[i].rgbGreen=i;//i/ratio;
            lpRGB[i].rgbRed=i;//i/ratio;
            lpRGB[i].rgbReserved=0;
        }
        /*for(i=0;i<10;i++) {
            lpRGB[i].rgbBlue=10;
            lpRGB[i].rgbGreen=10;
            lpRGB[i].rgbRed=10;
            lpRGB[i].rgbReserved=10;
        }
        for(i=lpbi->biClrUsed-10;i<(int)lpbi->biClrUsed;i++) {
            lpRGB[i].rgbBlue=245;
            lpRGB[i].rgbGreen=245;
            lpRGB[i].rgbRed=245;
            lpRGB[i].rgbReserved=0;
        }*/
        /*short	*lpPal=(short *)((LPSTR)lpbi+lpbi->biSize);
        lpbi->biClrUsed=(1<<bits);
        for(i=0; i<(short)lpbi->biClrUsed;i++) {
            lpPal[i]=i;
        }*/
    }
    lpbi->biClrImportant=lpbi->biClrUsed;

    return lpbi->biClrUsed;
}

#include "qfile.h"

exWAVEFILEHEADER waveheader;
QFile   hFile;

//write audio data to file by this callback function
BOOL CALLBACK exWriteAudioData(HANDLE hAudio, LPBYTE lpAudBuf, INT32 length)
{

    if(length) { //write audio data to file
        hFile.write((char *)lpAudBuf, length);
        waveheader.lDataLength+=length;

        //display audio data
//        exDrawAudio(hAudio, (short *)lpAudBuf,length);
    }
    else { //capture ended, so close the file
        waveheader.lFileLength+=waveheader.lDataLength;
        hFile.seek(0);
        hFile.write((LPSTR)&waveheader,sizeof(exWAVEFILEHEADER));
        hFile.close();
    }

    return 1;
}

DWORD	starttime;
extern long	elapsed;

//if length=0, ended
BOOL CALLBACK exMsgCallback(HANDLE hStream, LPBYTE lpStreamBuf, long length)
{
    static int count;
    static long TotalLength;
    long	currtime;

    if(!length) //stoped
        return 0;

    currtime=okGetTickCount()-elapsed;

    TotalLength+=length;
    if(currtime) {
        char str[200];
        sprintf(str," MPEG2 Captured Times= %d Seconds;  Section = %d;  Rate = %d (KB/S)     ",(okGetTickCount()-starttime)/1000,length, TotalLength/(okGetTickCount()-elapsed));
#if defined(Q_OS_WIN32)
        SetWindowTextA((HWND)mainwin->winId(), str);
#endif

        elapsed=okGetTickCount();
        TotalLength=0;
    }
    count++;

    return 1;
}


int main(int argc, char *argv[])
{
    QApplication a(argc, argv);

    MainWindow w;
    w.show();

    mainwin = &w;

    a.installEventFilter(&w);

    return a.exec();
}


