#include "selectbox.h"
#include "ui_selectbox.h"

#include <QMessageBox>

SelectBox::SelectBox(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::SelectBox)
{
    ui->setupUi(this);
}

SelectBox::~SelectBox()
{
    delete ui;
}

void SelectBox::showEvent(QShowEvent *event)
{
    ui->BOARDLIST->clear();
    InitDialog();
}

void SelectBox::SetBoard(HANDLE h)
{
    hBoard = h;
}

void SelectBox::SetCurrentNo(MLONG m)
{
    iCurrUsedNo = m;
}


int SelectBox::GetIndex()
{
    return ui->BOARDLIST->currentIndex();
}

//private slots
void SelectBox::on_pushButton_clicked()
{
    ui->BOARDLIST->clear();


    bFind=1;
    if(ui->NETDEVICE->isChecked()) {
        bFind |=2;
        bNetFind=1;
    }
    else
        bNetFind=0;
    InitDialog();
}

//private
void SelectBox::InitDialog(void)
{

    {
        //total=okGetSlotBoard(&lpBoardInfo);
        total=okGetImageDevice(&lpBoardInfo, MLONG(&bFind));
        if(bNetFind==-1) //first time
            bNetFind=bFind&1;

        if(bNetFind==1)
            {
                ui->NETDEVICE->setChecked(true);
            }
        else
            ui->NETDEVICE->setChecked(false);

        bFind=0;
    }

    if( !iVirtCode && (iCurrUsedNo>=total) ) { //one virtual card
        iVirtCode=okGetTypeCode(hBoard, szVirtName);
    }

    QString str;
    str = QString("%1")
            .arg(total, 0, 10);
    ui->TOTALBOARD->setText(str);
    for(i=0;i<total;i++) {

        str = QString(" No. %1 :     ID=%2 :  %3    ")
                .arg(i, 0, 10)
                .arg(lpBoardInfo[i].iBoardIdentCode, 0, 10)
                .arg(lpBoardInfo[i].szBoardName);

        ui->BOARDLIST->addItem(str);
    }
    if(iVirtCode) {
        str = QString(" Virtual:  ID Code=%1,  Name=%2 ")
                .arg(iVirtCode, 0, 10)
                .arg(szVirtName);
        ui->BOARDLIST->addItem(str);
        total++;
    }
    if(iCurrUsedNo<0)
        iCurrUsedNo=0;

    iCurrUsedNo=qMin(iCurrUsedNo,long(total-1));
    ui->BOARDLIST->setCurrentIndex(iCurrUsedNo);
    str = QString("%1")
            .arg(iCurrUsedNo, 0, 10);
    ui->CURRUSED->setText(str);
}
