#include "setlockbufferbox.h"
#include "ui_setlockbufferbox.h"

#if defined(Q_OS_WIN32)
    #include "windows.h"
#else
    #include "../share/winsim.h"
    #include "stdio.h"
#endif

SetLockBufferBox::SetLockBufferBox(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::SetLockBufferBox)
{
    ui->setupUi(this);

    UpdateWidget();
}

SetLockBufferBox::~SetLockBufferBox()
{
    delete ui;
}

//private
void SetLockBufferBox::UpdateWidget()
{
    long	currno = ui->INDEXBOARD->value();
    DWORD	offset,bufsize;

#if defined(Q_OS_WIN32)
    TCHAR	string[120];

    wsprintf(string, L"No. %d", currno);

    offset=GetPrivateProfileInt(string, L"Offset", 0, L"okacfg.ini");
    bufsize=GetPrivateProfileInt(string, L"Size", 0, L"okacfg.ini");
#else
    char	string[120];

    sprintf(string,"No. %d",currno);

    offset=GetPrivateProfileInt(string, "Offset", 0, "okacfg.ini");
    bufsize=GetPrivateProfileInt(string, "Size", 0, "okacfg.ini");
#endif

    offset/=1024; //to k
    bufsize/=1024;
    ui->BUFFEROFFSET->setText(QString::number(offset));
    ui->LOCKBUFSIZE->setText(QString::number(bufsize));
}

void SetLockBufferBox::on_INDEXBOARD_valueChanged(int arg1)
{
    UpdateWidget();
}

void SetLockBufferBox::on_pushButton_clicked()
{
#if defined(Q_OS_WIN32)
    TCHAR	string[120];
    TCHAR	outstr[120];
#else
    char	string[120];
    char	outstr[120];
#endif

    int currno = ui->INDEXBOARD->value();
    DWORD	offset,bufsize;

#if defined(Q_OS_WIN32)
    wsprintf(string, L"No. %d", currno);
#else
    sprintf(string,"No. %d",currno);
#endif
    offset = ui->BUFFEROFFSET->text().toInt();
    //offset=GetDlgItemInt(hDlg,IDC_BUFFEROFFSET,NULL,TRUE);
    bufsize = ui->LOCKBUFSIZE->text().toInt();
    //bufsize=GetDlgItemInt(hDlg,IDC_LOCKBUFSIZE,NULL,TRUE);

    offset*=1024; //to byte
    bufsize*=1024;

#if defined(Q_OS_WIN32)
    wsprintf(outstr, L"%d", offset);
    WritePrivateProfileString(string, L"Offset", outstr, L"okacfg.ini");
    wsprintf(outstr, L"%d", bufsize);
    WritePrivateProfileString(string, L"Size", outstr, L"okacfg.ini");
#else
    sprintf(outstr,"%d",offset);
    WritePrivateProfileString(string,"Offset",outstr,"okacfg.ini");
    sprintf(outstr,"%d",bufsize);
    WritePrivateProfileString(string,"Size",outstr,"okacfg.ini");
#endif
}

void SetLockBufferBox::on_pushButton_2_clicked()
{
    close();
}
