﻿#pragma execution_character_set("utf-8")
#include "signalbox.h"
#include "ui_signalbox.h"

#include "stdio.h"

#define DEGREE 5
#define DEGREELIMIT	DEGREE*0.8
#define MINLINE	10
#define MAXDIFFLINE	10

BOOL IsInput(HANDLE hBoard);
BOOL AutoSetChan(HANDLE hBoard);
BOOL APIENTRY exAutoSetVideoParams(HANDLE hBoard, int videotype, int scanlines, int fieldfrq, int sample43 );

bool sampleratio43=1;

SignalBox::SignalBox(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::SignalBox)
{
    ui->setupUi(this);
}

SignalBox::~SignalBox()
{
    delete ui;
}

void SignalBox::showEvent(QShowEvent *event)
{
    char	str[256];
    int		extsign=0,vidcolor=-1;
    int		ret;
    QString     qs;
//    BOOL	IsCameraDll();

    qs = "当前视频输入信息";
    qs += "     (";
    okGetTypeCode(hBoard, str);
    qs += str;
    qs += ")";
    this->setWindowTitle(qs);

    //scanlines=okSetVideoParam(hBoard,VIDEO_FRAMELINES,-1); //just for cards with D/A
    //okSetVideoParam(hBoard,VIDEO_FRAMELINES,scanlines); //init to extern sync
    //video exist
    ui->pushButton_AUTOSEARCH->setEnabled(true);

    extsign=okGetSignalParam(hBoard,SIGNAL_VIDEOEXIST);
    if(extsign==1) {
        qs = "检测到了信号源";
    }
    else if(extsign==0) {
        qs = "没有信号源";
    }
    else {//-1
        qs = "不支持";
        ui->pushButton_AUTOSEARCH->setEnabled(false);
    }

    vidcolor=okGetSignalParam(hBoard,SIGNAL_VIDEOCOLOR);
    if(extsign==1) {

        if(vidcolor==1)
            qs += "(Color)";
        else if(vidcolor==0)
            qs += "(B/W)";
    }
    ui->label_VIDEOEXIST->setText(qs);

    //video type
    if(extsign==1) {
        okWaitSignalEvent(hBoard, EVENT_ODDFIELD, 40);
        videotype=okGetSignalParam(hBoard,SIGNAL_VIDEOTYPE);
        if(videotype==1) //interlaced
            qs = "隔行信号(Interlaced)";
        else if(videotype==0) //non-interlaced
            qs = "逐行信号(Progressive)";
        else if(videotype==-1)
            qs = "不支持";


    }
    else
        qs = "未知";

    ui->label_VIDEOTYPE->setText(qs);

    //video scanlines
    scanlines=-1;
    if(extsign==1) {
        scanlines=okGetSignalParam(hBoard,SIGNAL_SCANLINES);
        if(scanlines==-1)
            qs = "不支持";
        else {
            sprintf(str,"%d ",scanlines);
            qs = str;
            qs += "行数/幅";
        }
    }
    else
        qs = "未知";
    ui->label_SCANLINES->setText(qs);

    //video field frequency
    if(extsign==1) {
        fieldfrq=okGetSignalParam(hBoard,SIGNAL_FIELDFREQ);
        if(fieldfrq==-1)
            qs = "不支持";
        else {
            sprintf(str,"%d ",fieldfrq);
            qs = str;
            qs += "场数/秒";
        }
    }
    else if(extsign==-1)
        qs = "未知";
    ui->label_FRAMEFREQ->setText(qs);


    //extern trigger
    ret=okGetSignalParam(hBoard,SIGNAL_EXTTRIGGER);


    if(ret==-1)
        qs = "不支持";
    else if(ret)
        qs = "触发状态";
    else
        qs = "无触发";
    ret=okGetSignalParam(hBoard,SIGNAL_CAPFINISHED);
    if(ret!=-1) { //supported
        if(ret==1)
            qs += ";      Captured";
        else
            qs += ";      No Captured";
    }
    ui->label_EXTTRIGGER->setText(qs);

    ui->radioButton_SAMPLERATIO43->setChecked(true);
    //firstly assume that can not detect signal infos
    ui->pushButton_SETVIDEO->setEnabled(false);
    ui->pushButton_AUTOFINESET->setEnabled(false);
    ui->radioButton_SAMPLERATIO43->setEnabled(false);
    ui->radioButton_SAMPLERATIO11->setEnabled(false);
    if(scanlines!=-1){
        ui->pushButton_SETVIDEO->setEnabled(true);
        ui->pushButton_AUTOFINESET->setEnabled(true);
        //if( okSetCaptureParam(hBoard,CAPTURE_HORZPIXELS,-1)!=-1 ) {
            ui->radioButton_SAMPLERATIO43->setEnabled(true);
            ui->radioButton_SAMPLERATIO11->setEnabled(true);
        //}
    }
    //if( (scanlines==625) && (videotype==1) || // PAL
    //	(scanlines==525) && (videotype==1) ) { //NTSC
    //	EnableWindow(GetDlgItem(hDlg,IDC_SAMPLERATIO43),FALSE);
    //	EnableWindow(GetDlgItem(hDlg,IDC_SAMPLERATIO11),FALSE);
    //}

    //test out trigger
    okPutSignalParam(hBoard,PUTSIGNAL_TRIGGER,0xff);

    //enable vert sync
    okPutSignalParam(hBoard,PUTSIGNAL_VERTSYNC,0x1);
}

void SignalBox::SetBoard(HANDLE h)
{
    hBoard = h;
}

void SignalBox::on_pushButton_ReTest_clicked()
{
    showEvent(nullptr);
}

void SignalBox::on_pushButton_AUTOSEARCH_clicked()
{
    AutoSetChan(hBoard);
    showEvent(nullptr);
}

BOOL AutoSetChan(HANDLE hBoard)//autosetchan return=TRUE(exist)	FALSE(not exist)
{
    long boardtype;
    long source;
    short sync,sign;
    long syncsign;
    int totalsource;
    long iTypeCode;

    iTypeCode=okGetTypeCode(hBoard,NULL);

    totalsource=0xb00+okSetVideoParam(hBoard,VIDEO_SOURCECHAN,0xbff);	//DP channeles
    if(totalsource)
    {
        for(source=0xb00;source<totalsource;source++)
        {
            okSetVideoParam(hBoard,VIDEO_SOURCECHAN,source);
            Sleep(500);

            if(IsInput(hBoard))
            {
                return TRUE;
            }
        }
    }

    totalsource=0xa00+okSetVideoParam(hBoard,VIDEO_SOURCECHAN,0xaff);		//sdi channeles
    if(totalsource)
    {
        for(source=0xa00;source<totalsource;source++)
        {
            okSetVideoParam(hBoard,VIDEO_SOURCECHAN,source);
            Sleep(500);

            if(IsInput(hBoard))
            {
                return TRUE;
            }
        }
    }
    totalsource=0x900+okSetVideoParam(hBoard,VIDEO_SOURCECHAN,0x9ff);		//hdmi(Ypbpr) channeles
    if(totalsource)
    {
        for(source=0x900;source<totalsource;source++)
        {
            okSetVideoParam(hBoard,VIDEO_SOURCECHAN,source);
            Sleep(500);

            if(IsInput(hBoard))
            {
                return TRUE;
            }
        }
    }
    totalsource=0x800+okSetVideoParam(hBoard,VIDEO_SOURCECHAN,0x8ff);		//DVI channeles
    if(totalsource)
    {
        for(source=0x800;source<totalsource;source++)
        {
            okSetVideoParam(hBoard,VIDEO_SOURCECHAN,source);
            Sleep(500);

            if(IsInput(hBoard))
            {
                return TRUE;
            }
        }
    }
    totalsource=0x400+okSetVideoParam(hBoard,VIDEO_SOURCECHAN,0x4ff);		//YPrPb video channele
    if(totalsource && (okGetTypeCode(hBoard,NULL) != 2330))
    {
        for(source=0x400;source<totalsource;source++)
        {
            okSetVideoParam(hBoard,VIDEO_SOURCECHAN,source);

            syncsign=MAKELONG(1,source-0x400);
            okSetVideoParam(hBoard,VIDEO_SYNCSIGCHAN,syncsign);

            Sleep(500);

            if(IsInput(hBoard))
            {
                return TRUE;
            }
        }
    }


    totalsource=0x200+okSetVideoParam(hBoard,VIDEO_SOURCECHAN,0x2ff);		//rgb/vga video channeles
    if(totalsource)
    {
        for(source=0x200;source<totalsource;source++)
        {
            okSetVideoParam(hBoard,VIDEO_SOURCECHAN,source);

            sign=source-0x200;
            for(sync = 4;sync >= 0;sync--)
            {
                syncsign=MAKELONG(sync,sign);
                okSetVideoParam(hBoard,VIDEO_SYNCSIGCHAN,syncsign);
                Sleep(500);
                if(IsInput(hBoard))
                {
                    return TRUE;
                }
            }

        }
    }


    totalsource=0x100+okSetVideoParam(hBoard,VIDEO_SOURCECHAN,0x1ff);		//S-Video channeles
    if(totalsource)
    {
        for(source=0x100;source<totalsource;source++)
        {
            okSetVideoParam(hBoard,VIDEO_SOURCECHAN,source);
            Sleep(500);

            if(IsInput(hBoard))
            {
                return TRUE;
            }
        }
    }

    totalsource=okSetVideoParam(hBoard,VIDEO_SOURCECHAN,0x0ff);		//Comp. Video channles
    if(totalsource)
    {
        for(source=0;source<totalsource;source++)
        {

            if (iTypeCode <2000)
            {
                okSetVideoParam(hBoard,VIDEO_SOURCECHAN,source);
                sign=source;
                for(sync = 0;sync< 5;sync++)
                {
                    syncsign=MAKELONG(sync,sign);
                    okSetVideoParam(hBoard,VIDEO_SYNCSIGCHAN,syncsign);
                    Sleep(500);
                    if(IsInput(hBoard))
                    {
                        return TRUE;
                    }
                }
            }
            else
            {
                okSetVideoParam(hBoard,VIDEO_SOURCECHAN,source);
                Sleep(500);

                if(IsInput(hBoard))
                {
                    return TRUE;
                }
            }

        }
    }

    return FALSE;
}

BOOL IsInput(HANDLE hBoard)
{
    int degree=10;
//	int fieldfrq[DEGREE]={0};
//	int averfield;
    int scanline[DEGREE]={0};
    int averline;
    int i;
    int count1,count2;

    for(i=0,count1=0;i<DEGREE;i++)
    {
// 		Sleep(5);

        if(okGetSignalParam(hBoard,SIGNAL_VIDEOEXIST)==1)
            count1++;

        if(count1>DEGREELIMIT)
            break;
    }

    if(count1>DEGREELIMIT)
    {
        for(i=0,averline=0;i<DEGREE;i++)//for(i=0,averfield=0,averline=0;i<DEGREE;i++)
        {
            Sleep(40);
//			fieldfrq[i]=okGetSignalParam(hBoard,SIGNAL_FIELDFREQ);
//			averfield+=fieldfrq[i];
            scanline[i]=okGetSignalParam(hBoard,SIGNAL_SCANLINES);
            averline+=scanline[i];
        }
//		averfield=averfield/DEGREE;
        averline=averline/DEGREE;

        if(averline>MINLINE)//if(averfield>MINFREQ && averline>MINLINE)
        {
            for(i=0,count2=0;i<DEGREE;i++)
            {
                int diffline;
//				int difffield;

//				difffield=fieldfrq[i]-averfield;
                diffline=scanline[i]-averline;
                if((abs(diffline)) < MAXDIFFLINE)//if(fabs(difffield)<MAXDIFFFIELD && fabs(diffline)<MAXDIFFLINE)
                    count2++;
            }

            if(count2>DEGREELIMIT)
                return TRUE;
            else
                return FALSE;

        }

        else if(averline==-1)
            return TRUE;
        else
            return FALSE;
    }
    else
        return FALSE;

}

void SignalBox::on_pushButton_SETVIDEO_clicked()
{
    exAutoSetVideoParams(hBoard,videotype, scanlines, fieldfrq, sampleratio43);

    okPutSignalParam(hBoard,PUTSIGNAL_VERTSYNC,0x0);
    close();
}

BOOL APIENTRY exAutoSetVideoParams(HANDLE hBoard, int videotype, int scanlines, int fieldfrq, int sample43 )
{

    long	tvstandard;
    long	samppixel,sampfreq,videoshift;
    RECT	rect;

        //scanlines=1220;
        //videotype=0;
        //fieldfrq=60;
        //sample43=1;


    //1.video type, 2. sample mode as video type
    okSetVideoParam(hBoard,VIDEO_SIGNALTYPE,videotype);
    okSetCaptureParam(hBoard,CAPTURE_SAMPLEFIELD,videotype); //0: field 1: frame

    //3.video standard 4.hp and vl, 5.frq segment
    //6 vidoe shift 7, sample rect
    //4:3

    if( (scanlines==625) && (videotype==1) ) { //interlace
        if(sample43 ) { //4:3
            okSetVideoParam(hBoard,VIDEO_FREQSEG,0); //lo seg
            tvstandard=0; //PAL
            okSetVideoParam(hBoard,VIDEO_TVSTANDARD,tvstandard);
            SetRect(&rect,0,0,768,576);
        }
        else { //1:1
            tvstandard=0; //PAL
            okSetVideoParam(hBoard,VIDEO_TVSTANDARD,tvstandard);
            //first do vidoe rect shift
            videoshift=okSetVideoParam(hBoard,VIDEO_RECTSHIFT,-1);
            videoshift=MAKELONG( LOWORD(videoshift)*710/945, HIWORD(videoshift));
            okSetVideoParam(hBoard,VIDEO_RECTSHIFT,videoshift);

            okSetVideoParam(hBoard,VIDEO_FREQSEG,0); //lo seg
            tvstandard=2; //non-standard
            okSetVideoParam(hBoard,VIDEO_TVSTANDARD,tvstandard);
            okSetCaptureParam(hBoard,CAPTURE_HORZPIXELS,709);
            okSetCaptureParam(hBoard,CAPTURE_VERTLINES,625);
            SetRect(&rect,0,0,576,576);
        }
    } else if( (scanlines==525) && (videotype==1) ) {
        if(sample43 ) { //4:3
            tvstandard=1; //NTSC
            okSetVideoParam(hBoard,VIDEO_TVSTANDARD,tvstandard);
            okSetVideoParam(hBoard,VIDEO_FREQSEG,0); //lo seg
            SetRect(&rect,0,0,640,480);
        }
        else { //1:1
            tvstandard=1; //NTSC
            okSetVideoParam(hBoard,VIDEO_TVSTANDARD,tvstandard);
            //first do vidoe rect shift
            videoshift=okSetVideoParam(hBoard,VIDEO_RECTSHIFT,-1);
            videoshift=MAKELONG( LOWORD(videoshift)*591/788,HIWORD(videoshift));
            okSetVideoParam(hBoard,VIDEO_RECTSHIFT,videoshift);

            tvstandard=2; //non-standard
            okSetVideoParam(hBoard,VIDEO_TVSTANDARD,tvstandard);
            okSetVideoParam(hBoard,VIDEO_FREQSEG,0); //lo seg
            okSetCaptureParam(hBoard,CAPTURE_HORZPIXELS,591);
            okSetCaptureParam(hBoard,CAPTURE_VERTLINES,525);
            SetRect(&rect,0,0,480,480);
        }
    }

    else
    {
        tvstandard=2;//non-standard


        okSetVideoParam(hBoard,VIDEO_TVSTANDARD,tvstandard);

        if(sample43)
            samppixel=(long)(scanlines*1.5104); //1.0 sample in 4:3
        else
            samppixel=(long)(scanlines*1.1328); //0.76 sample in 1:1


re_calc:
        sampfreq=scanlines*samppixel/1000*fieldfrq/1000; //to unit MHz
        if(videotype==1) //interlaced
            sampfreq/=2;

        {
            //char	str[120];

            //sprintf(str,"%d",sampfreq);
            //MessageBox(NULL,str,"1",MB_OK);
        }

        if(sampfreq<14.75)
            sampfreq=0; //low
        else if(sampfreq<31)
            sampfreq=1; //middle
        else if(sampfreq<61) {
            sampfreq=2; //high
            if( okSetVideoParam(hBoard,VIDEO_FREQSEG,sampfreq)<0) {
                //not support supper high (max 30MHz)
                samppixel=30000000/(scanlines*(fieldfrq>>videotype)); //
                goto re_calc;
            }
        }
        else if(sampfreq<=120) {
            sampfreq=3; //super high
            if( okSetVideoParam(hBoard,VIDEO_FREQSEG,sampfreq)<0) {
                //not support supper high (max 60MHz)
                samppixel=60000000/(scanlines*(fieldfrq>>videotype)); //
                goto re_calc;
            }
        }
        else {
            sampfreq=4; //ultra high
            if( okSetVideoParam(hBoard,VIDEO_FREQSEG,sampfreq)<0) {
                //not support supper high (max 60MHz)
                samppixel=120000000/(scanlines*(fieldfrq>>videotype)); //
                goto re_calc;
            }
        }
        okSetVideoParam(hBoard,VIDEO_FREQSEG,sampfreq);

        okSetCaptureParam(hBoard,CAPTURE_HORZPIXELS,samppixel);
        okSetCaptureParam(hBoard,CAPTURE_VERTLINES,scanlines);

        //vidoe rect shift
        //videoshift=MAKELONG( (short)(samppixel*0.165),(short)(samppixel*0.0512));
        if( (okGetTypeCode(hBoard,NULL)/1000)==6)  //digital cards
            videoshift=0;
        else //analog cards
            videoshift=MAKELONG( (short)(samppixel*0.09),(short)(scanlines*0.02));
        okSetVideoParam(hBoard,VIDEO_RECTSHIFT,videoshift);

        //do again after set shift
        okSetVideoParam(hBoard,VIDEO_TVSTANDARD,tvstandard);

        SetRect(&rect,0,0,(long)(samppixel*0.8),(long)(scanlines*0.9));

    }

    okSetTargetRect(hBoard,VIDEO,&rect);

    rect.right -=rect.left;
    rect.left=0;
    rect.bottom -=rect.top;
    rect.top=0;
    okSetTargetRect(hBoard,BUFFER,&rect);


    return tvstandard;
}

void SignalBox::on_radioButton_SAMPLERATIO43_toggled(bool checked)
{
    sampleratio43=1;
}

void SignalBox::on_radioButton_SAMPLERATIO11_toggled(bool checked)
{
    sampleratio43=0;
}

void SignalBox::on_pushButton_AUTOFINESET_clicked()
{
    okAutoSetCapRect(hBoard,0,0);
    close();
}
