﻿#ifndef SIGNALBOX_H
#define SIGNALBOX_H

#include <QDialog>

#if defined(Q_OS_WIN64)
    #include "Windows.h"
    #include "Okapi64.h"
#elif defined(Q_OS_WIN32)
    #include "windows.h"
    #include "Okapi32.h"
#else
    #include "../share/winsim.h"
    #include "../share/okapi64.h"
#endif

namespace Ui {
class SignalBox;
}

class SignalBox : public QDialog
{
    Q_OBJECT

public:
    explicit SignalBox(QWidget *parent = 0);
    ~SignalBox();

    void showEvent(QShowEvent *event);

private:
    Ui::SignalBox *ui;

private:
    HANDLE		hBoard;

    int		videotype,scanlines,fieldfrq;

public:
    void SetBoard(HANDLE h);
private slots:
    void on_pushButton_ReTest_clicked();
    void on_pushButton_SETVIDEO_clicked();
    void on_pushButton_AUTOSEARCH_clicked();
    void on_radioButton_SAMPLERATIO43_toggled(bool checked);
    void on_radioButton_SAMPLERATIO11_toggled(bool checked);
    void on_pushButton_AUTOFINESET_clicked();
};

#endif // SIGNALBOX_H
